package bunmodel

import (
	"time"

	"gitea.dwysokinski.me/twhelp/dcbot/internal/domain"
	"github.com/google/uuid"
	"github.com/uptrace/bun"
)

type Monitor struct {
	bun.BaseModel `bun:"base_model,table:monitors,alias:monitor"`

	ID        uuid.UUID `bun:"id,pk,nullzero"`
	GroupID   uuid.UUID `bun:"group_id"`
	TribeID   int64     `bun:"tribe_id,nullzero"`
	CreatedAt time.Time `bun:"created_at,nullzero"`
}

func (m Monitor) ToDomain() domain.Monitor {
	return domain.Monitor{
		ID:        m.ID.String(),
		GroupID:   m.GroupID.String(),
		TribeID:   m.TribeID,
		CreatedAt: m.CreatedAt,
	}
}
