package domain_test

import (
	"testing"

	"gitea.dwysokinski.me/twhelp/dcbot/internal/domain"
	"github.com/stretchr/testify/assert"
)

func TestEnnoblement_IsBarbarian(t *testing.T) {
	t.Parallel()

	assert.True(t, domain.Ennoblement{
		NewOwner: domain.NullPlayerMeta{
			Player: domain.PlayerMeta{
				ID: 123,
			},
			Valid: true,
		},
	}.IsBarbarian())

	assert.False(t, domain.Ennoblement{
		NewOwner: domain.NullPlayerMeta{
			Player: domain.PlayerMeta{
				ID: 123,
			},
			Valid: true,
		},
		Village: domain.VillageMeta{
			Player: domain.NullPlayerMeta{
				Player: domain.PlayerMeta{
					ID: 125,
				},
				Valid: true,
			},
		},
	}.IsBarbarian())
}

func TestEnnoblement_IsSelfConquer(t *testing.T) {
	t.Parallel()

	assert.True(t, domain.Ennoblement{
		NewOwner: domain.NullPlayerMeta{
			Player: domain.PlayerMeta{
				ID: 123,
			},
			Valid: true,
		},
		Village: domain.VillageMeta{
			Player: domain.NullPlayerMeta{
				Player: domain.PlayerMeta{
					ID: 123,
				},
				Valid: true,
			},
		},
	}.IsSelfConquer())

	assert.False(t, domain.Ennoblement{
		NewOwner: domain.NullPlayerMeta{
			Player: domain.PlayerMeta{
				ID: 123,
			},
			Valid: true,
		},
	}.IsSelfConquer())

	assert.False(t, domain.Ennoblement{
		NewOwner: domain.NullPlayerMeta{
			Player: domain.PlayerMeta{
				ID: 123,
			},
			Valid: true,
		},
		Village: domain.VillageMeta{
			Player: domain.NullPlayerMeta{
				Player: domain.PlayerMeta{
					ID: 125,
				},
				Valid: true,
			},
		},
	}.IsSelfConquer())
}
